function EUF_PartyInfo_OnLoad(this)
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("PLAYER_LOGIN");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
    this:RegisterEvent("PARTY_MEMBER_ENABLE");
    this:RegisterEvent("PARTY_MEMBER_DISABLE");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("UNIT_PHASE");
	this:RegisterEvent("UNIT_COMBAT");
	this:RegisterEvent("UNIT_SPELLMISS");
    this:RegisterEvent("UNIT_FACTION");
	this:RegisterEvent("UNIT_DYNAMIC_FLAGS");
	this:RegisterEvent("UNIT_FLAGS");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_PORTRAIT_UPDATE");
	this:RegisterEvent("UNIT_TARGET");
	this:RegisterEvent("UNIT_POWER");
	this:RegisterEvent("UNIT_MAXPOWER");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_HEALTH_FREQUENT");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_MAXMANA");
    this:RegisterEvent("UNIT_RAGE");
    this:RegisterEvent("UNIT_MAXRAGE");
    this:RegisterEvent("UNIT_ENERGY");
    this:RegisterEvent("UNIT_MAXENERGY");
    this:RegisterEvent("UNIT_LEVEL");
	this:RegisterEvent("UNIT_DISPLAYPOWER");
	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("PLAYER_FLAGS_CHANGED");
    this:RegisterEvent("PARTY_LEADER_CHANGED");
    this:RegisterEvent("RAID_ROSTER_UPDATE");
	this:RegisterEvent("VOICE_STATUS_UPDATE");
	this:RegisterEvent("PARTY_LFG_RESTRICTED");

	this:RegisterEvent("PLAYER_REGEN_ENABLED");
end

function EUF_PartyInfo_OnEvent(self,event,...)
	local name = ...;

    if (event == "ADDON_LOADED" and name == EUF_SysAddonName)
		or event == "PLAYER_ENTERING_WORLD"
		or event == "PLAYER_LOGIN"
        or event == "PARTY_MEMBERS_CHANGED"
		or event == "PARTY_LEADER_CHANGED"
		or event == "VOICE_STATUS_UPDATE"
		or event == "PARTY_LFG_RESTRICTED"
        or event == "RAID_ROSTER_UPDATE"
		or event == "UNIT_LEVEL"
		or event == "PLAYER_REGEN_ENABLED" then

        EUF_HidePartyToggle();
        EUF_FramePartyInfo_Update();
        EUF_PartyMember_CheckClass();	
    end;
end

function EUF_PartyInfo_Update(unit)
    if not unit then
        return;
    end;

    local unitExists, _,unitId = string.find(unit, "^party(%d)$");

    if not unitExists then
        return;
    end;
    
    -- Set class
    if EUF_CurrentOptions["PARTYCLASS"] == 1 then
        local class = UnitClass(unit);

        if class then
            if EUF_CurrentOptions["PARTYCLASSABRV"] == 1 then
                class = string.sub(class, 1, 3);
            end;

            getglobal("EUF_PartyInfo"..unitId.."Class"):SetText(class);
        end;
    else
        getglobal("EUF_PartyInfo"..unitId.."Class"):SetText("");
    end;

    -- Set level
    if EUF_CurrentOptions["PARTYLEVEL"] == 1 then
        local level = UnitLevel(unit);

        if level then
            if level < 1 then
                level = "??";
            end;

            getglobal("EUF_PartyInfo"..unitId.."Level"):SetText(level);
        end;
    else
        getglobal("EUF_PartyInfo"..unitId.."Level"):SetText("");
    end;
end

function EUF_FramePartyInfo_Update()
    local i;

    for i = 1, GetNumSubgroupMembers(), 1 do
        EUF_PartyInfo_Update("party"..i);
    end;
end

function EUF_PartyMember_CheckClass()
    local n = GetNumSubgroupMembers();

    if n > 0 then
        for i = 1, n do
            local _, enClass = UnitClass("party"..i);

            if EUF_CurrentOptions["PARTYCOLOR"] == 1 and enClass then
                getglobal("PartyMemberFrame"..i.."Name"):SetTextColor(RAID_CLASS_COLORS[enClass].r,RAID_CLASS_COLORS[enClass].g,RAID_CLASS_COLORS[enClass].b);
            else
                getglobal("PartyMemberFrame"..i.."Name"):SetTextColor(1, 0.8, 0);
            end;
        end;
    end;
end

function EUF_HidePartyToggle()
	if not InCombatLockdown() then
		if EUF_CurrentOptions["PARTYSHOW"] == 0 then
			local i;
			for i = 1, 4, 1 do
				getglobal("PartyMemberFrame"..i):Hide();
			end;
		elseif (not UnitInRaid("player")) and (GetNumSubgroupMembers() > 0) then
			local i;
			for i = 1, 4, 1 do
				if UnitInParty("party"..i) then
					getglobal("PartyMemberFrame"..i.."HealthBar"):RegisterAllEvents();
					getglobal("PartyMemberFrame"..i.."ManaBar"):RegisterAllEvents();
					getglobal("PartyMemberFrame"..i):Show();
				end;
			end;
		end;
	else
		print("You cannot hide or show party frames while in combat.");
	end;
end;
